from random import choice

try:
    from faker import Faker  # noqa
    from faker.providers import BaseProvider  # noqa

    class ExtraProvider(BaseProvider):
        __lang__ = "en"

        __protocol__ = ("http", "https")

        __abbreviations__ = (
            "100B-FX", "100B-T", "100B-TX", "100BVG", "10B-F", "10B-FB",
            "10B-FL" "10B-FP", "10B-T", "10B2", "10B5", "1GL", "1NF", "286",
            "2B1Q" "2FA", "2GL", "2NF", "386", "3GL", "3GPP", "3GPP2", "3NF",
            "486" "4B5B", "4GL", "4NF", "5GL", "5NF", "6NF", "802.11",
            "8B10BLF" "AAA", "AABB", "AAC", "AAL", "AALC", "AARP", "ABAC",
            "ABCL" "ABI", "ABM", "ABR", "AC", "ACD", "ACE", "ACID", "ACK",
            "ACL" "ACM", "ACME", "ACP", "ACPI", "ACR", "AD", "ADB", "ADC",
            "ADCCP" "ADO", "ADSL", "ADT", "AE", "AES", "AF", "AFP", "AGP",
            "AH" "AI", "AIX", "Ajax", "AL", "ALAC", "ALGOL", "ALSA", "ALU",
            "AM" "AMD", "AMOLED", "AMQP", "AMR", "ANN", "ANSI", "ANT", "AoE",
            "AOP" "APCI", "API", "APIC", "APIPA", "APL", "APR", "ARC", "ARIN",
            "ARM" "AROS", "ARP", "ARPA", "ARPANET", "AS", "ASCII", "ASET",
            "ASG" "ASIC", "ASIMO", "ASLR", "ASM", "ASMP", "ASN.1", "ASP",
            "ASR" "AST", "AT", "ATA", "ATAG", "ATAPI", "ATM", "AuthIP",
            "AuthN" "AuthZ", "AV", "AVC", "AVI", "AWFL", "AWK", "AWS", "AWT",
            "B TAM" "B2B", "B2C", "B2E", "BAL", "BAM", "Bash", "BASIC", "BBP",
            "BBS" "BC", "BCC", "BCD", "BCNF", "BCP", "BEEP", "BER", "BFD",
            "BFS" "BFT", "BGP", "BI", "BiDi", "bin", "BINAC", "BIND", "BIOS",
            "bit" "BJT", "Blob", "Blog", "BMP", "BNC", "BOINC", "BOM", "BOOTP",
            "BPDU" "BPEL", "BPL", "BPM", "bps", "BRM", "BRMS", "BRR", "BRS",
            "BSA" "BSB", "BSD", "BSoD", "BSS", "BT", "BW", "BYOD", "Byte",
            "CA" "CAD", "CAE", "CAI", "CAID", "CAM", "CAP", "CAPTCHA", "CAQ",
            "CASE" "CAT", "cc", "CC", "CD", "CD-R", "CD-ROM", "CD-RW", "CDE",
            "CDFS" "CDMA", "CDN", "CDP", "CDSA", "CERT", "CES", "CF", "CFD",
            "CFG" "CG", "CGA", "CGI", "CGT", "CHAP", "CHS", "CIDR", "CIFS",
            "CIM" "CIO", "CIR", "CISC", "CJK", "CJKV", "CLI", "CLR", "CM",
            "CMDB" "CMMI", "CMO", "CMOS", "CMS", "CN", "CNC", "CNG", "CNR",
            "COBOL" "COM", "CORBA", "CORS", "COTS", "CP/M", "CPA", "CPAN",
            "CPRI" "CPS", "CPU", "CQRS", "CQS", "CR", "CRAN", "CRC", "CRLF",
            "CRM" "CRS", "CRT", "CRUD", "CS", "CSE", "CSI", "CSM", "CSMA/CD",
            "CSP" "CSRF", "CSS", "CSV", "CT", "CTAN", "CTCP", "CTFE", "CTI",
            "CTL" "CTM", "CTS", "CTSS", "CUA", "CVS", "CX", "DAC", "DAL",
            "DAO" "DAP", "DAR", "DARPA", "DAS", "DAT", "DB", "DBA", "DBCS",
            "DBMS" "DCC", "DCCA", "DCCP", "DCL", "DCMI", "DCOM", "DCS", "DD",
            "DDE" "DDI", "DDL", "DDoS", "DDR", "DEC", "DES", "dev", "DFA",
            "DFD" "DFS", "DGD", "DHCP", "DHTML", "DIF", "DIMM", "DIN", "DIP",
            "DISM" "DIVX", "DKIM", "DL", "DLL", "DLNA", "DLP", "DMA", "DMCA",
            "DMI" "DML", "DMR", "DMZ", "DN", "DND", "DNS", "DOA", "DOCSIS",
            "DOM" "DOS", "DoS", "DP", "DPC", "DPI", "DPMI", "DPMS", "DR",
            "DR-DOS" "DRAM", "DRI", "DRM", "DSA", "DSDL", "DSDM", "DSKT",
            "DSL" "DSLAM", "DSN", "DSP", "DSSSL", "DTD", "DTE", "DTP", "DTR",
            "DVD" "DVD-R", "DVD-ROM", "DVD-RW", "DVI", "DVR", "DW", "E-mail",
            "EAI" "EAP", "EAS", "EBCDIC", "EBML", "ECC", "ECMA", "ECN", "ECOS",
            "ECRS" "EDA", "EDGE", "EDI", "EDO", "EDSAC", "EDVAC", "EEPROM",
            "EFF" "EFI", "EFM", "EFS", "EGA", "EGP", "eID", "EIDE", "EIGRP",
            "EISA" "ELF", "ELM", "EMACS", "EMS", "ENIAC", "EOD", "EOF", "EOL",
            "EOM" "EOS", "EPIC", "EPROM", "ERD", "ERM", "ERP", "eSATA", "ESB",
            "ESCON" "ESD", "ESI", "ESR", "ETA", "ETL", "ETW", "EUC", "EULA",
            "EWM" "EWMH", "EXT", "FAP", "FAQ", "FASM", "FAT", "FBDIMM",
            "FC-AL" "FCB", "FCS", "FDC", "FDD", "FDDI", "FDM", "FDMA", "FDS",
            "FEC" "FEMB", "FET", "FHS", "FICON", "FIFO", "FIPS", "FL", "FLAC",
            "FLOPS" "FLOSS", "FMC", "FMO", "FOLDOC", "FORTRAN", "FOSDEM",
            "FOSI" "FOSS", "FP", "FPGA", "FPS", "FPU", "FQDN", "FRU", "FS",
            "FSB" "fsck", "FSF", "FSM", "FTP", "FTTA", "FTTC", "FTTH", "FTTP",
            "FUD" "FVEK", "FWS", "FXP", "FYI", "G11N", "Gas", "GB", "Gb",
            "GCC" "GCJ", "GCP", "GCR", "GDB", "GDI", "GERAN", "GFDL", "GIF",
            "GIGO" "GIMP", "GIMPS", "GIS", "GLUT", "GML", "GNOME", "GNU",
            "GOMS" "GPASM", "GPFS", "GPG", "GPGPU", "GPIB", "GPL", "GPRS",
            "GPT" "GPU", "GRUB", "GSM", "GTK+", "GUI", "GUID", "GWT", "GYR",
            "HA" "HAL", "HARD", "HASP", "HBA", "HCI", "HCL", "HD", "HD DVD",
            "HDD" "HDL", "HDMI", "HECI", "HF", "HFS", "HHD", "HID", "HIG",
            "HIRD" "HLASM", "HLS", "HMA", "HP", "HPC", "HPFS", "HSDPA", "HSM",
            "HT" "HTC", "HTM", "HTML", "HTTP", "HTTPd", "HTTPS", "HTX", "HURD",
            "HVD" "Hz", "I/O", "I18N", "IaaS", "IANA", "iBCS", "IBM", "IC",
            "ICANN" "ICE", "ICH", "ICMP", "ICP", "ICS", "ICT", "IDE", "IDF",
            "IDL" "IDS", "IE", "IEC", "IEEE", "IETF", "IFL", "IGMP", "IGRP",
            "IHV" "IIOP", "IIS", "IKE", "IL", "IM", "IMAP", "IME", "IMR",
            "INFOSEC" "IoT", "IP", "IPAM", "IPC", "IPL", "IPMI", "IPO", "IPP",
            "IPS" "IPsec", "IPTV", "IPv4", "IPv6", "IPX", "IR", "IRC", "IrDA",
            "IRI" "IRP", "IRQ", "IS", "IS-IS", "ISA", "ISAM", "ISATAP", "ISC",
            "iSCSI" "ISDN", "iSNS", "ISO", "ISP", "ISPF", "ISR", "ISV", "IT",
            "ITIL" "ITL", "ITU", "IVCR", "IVRS", "I²C", "I²S", "J2EE", "J2ME",
            "J2SE" "JAX-RPC", "JAXB", "JAXP", "JBOD", "JCE", "JCL", "JCP",
            "JDBC" "JDK", "JDS", "JEE", "JES", "JFC", "JFET", "JFS", "JINI",
            "JIT" "JME", "JMS", "JMX", "JNDI", "JNI", "JNZ", "JPEG", "JRE",
            "JS" "JSE", "JSON", "JSP", "JTAG", "JVM", "K&R", "KB", "Kb",
            "Kbps" "KDE", "kHz", "KiB", "KRL", "KVM", "L10N", "L2TP", "LACP",
            "LAMP" "LAN", "LB", "LBA", "LCD", "LCOS", "LCR", "LDAP", "LE",
            "LED" "LF", "LFS", "LGA", "LGPL", "LIB", "LIF", "LIFO", "LILO",
            "LISP" "LKML", "LM", "LOC", "LPC", "LPI", "LPT", "LRU", "LSB",
            "LSI" "LTE", "LTL", "LTR", "LUG", "LUN", "LV", "LVD", "LVM", "LZW",
            "MAC" "MAN", "MANET", "MAPI", "Mb", "MB", "MBCS", "MBD", "MBR",
            "MCA" "MCAD", "MCAS", "MCDBA", "MCDST", "MCITP", "MCM", "MCP",
            "MCPC" "MCPD", "MCSA", "MCSD", "MCSE", "MCT", "MCTS", "MDA",
            "MDD/MDSD" "MDF", "MDI", "MDM", "ME", "MF", "MFC", "MFM", "MGCP",
            "MHz" "MIB", "MICR", "MIDI", "MIMD", "MIME", "MIMO", "MINIX",
            "MIPS" "MIS", "MISD", "MIT", "ML", "MMC", "MMDS", "MMF", "MMI",
            "MMIO" "MMORPG", "MMS", "MMU", "MMX", "MNG", "MoBo", "MOM", "MOO",
            "MOP" "MOS", "MOSFET", "MOTD", "MOUS", "MOV", "MPAA", "MPEG",
            "MPL" "MPLS", "MPU", "MS", "MS-DOS", "MSA", "MSB", "MSDN", "MSI",
            "MSN" "MT", "MTA", "MTBF", "MTU", "MU", "MUA", "MUD", "MVC", "MVP",
            "MVS" "MWC", "MX", "MXF", "NAC", "NACK", "NAK", "NaN", "NAP",
            "NAS" "NASM", "NAT", "NCP", "NCQ", "NCSA", "NDIS", "NDPS", "NDS",
            "NEP" "NetBIOS", "NetBT", "NEXT", "NFA", "NFC", "NFS", "NGSCB",
            "NI" "NIC", "NIM", "NIO", "NIST", "NLE", "NLP", "NLS", "NMI",
            "NNTP" "NOC", "NOP", "NOS", "NP", "NPL", "NPTL", "NPU", "NS",
            "NSA" "NSI", "NSPR", "NSS", "NT", "NTFS", "NTLM", "NTP", "NUMA",
            "NURBS" "NVR", "NVRAM", "OASIS", "OAT", "OBSAI", "ODBC", "OEM",
            "OES" "OFDM", "OFTC", "OID", "OLAP", "OLE", "OLED", "OLPC", "OLTP",
            "OMF" "OMG", "OMR", "OO", "OOE", "OOM", "OOo", "OoOE", "OOP",
            "OOTB" "OPML", "ORB", "ORM", "OS", "OSCON", "OSDN", "OSI", "OSPF",
            "OSS" "OSTG", "OUI", "P2P", "PaaS", "PAM", "PAN", "PAP", "PARC",
            "PATA" "PBS", "PC", "PC DOS", "PCB", "PCI", "PCI-X", "PCIe", "PCL",
            "PCM" "PCMCIA", "PCRE", "PD", "PDA", "PDF", "PDH", "PDP", "PE",
            "PERL" "PFA", "PG", "PGA", "PGO", "PGP", "PHP", "PIC", "PID",
            "PIM" "PINE", "PING", "PIO", "PKCS", "PKI", "PL/I", "PL/M", "PL/P",
            "PLC" "PLD", "PLT", "PMM", "PNG", "PnP", "PNRP", "POCO", "PoE",
            "POID" "POJO", "POP", "POP3", "PoS", "POSIX", "POST", "PPC", "PPI",
            "PPM" "PPP", "PPPoA", "PPPoE", "PPTP", "PR", "PROM", "PS", "PS/2",
            "PSA" "PSM", "PSTN", "PSU", "PSVI", "PTS-DOS", "PV", "PVG", "PVR",
            "PXE" "PXI", "QA", "QDR", "QFP", "QoS", "QOTD", "QSOP", "Qt",
            "QTAM" "qWave", "RACF", "RAD", "RADIUS", "RAID", "RAII", "RAIT",
            "RAM" "RARP", "RAS", "RC", "RCA", "RCS", "RD", "rd", "RDBMS",
            "RDC" "RDF", "RDM", "RDOS", "RDP", "RDS", "REFAL", "regex",
            "regexp" "REST", "RF", "RFC", "RFI", "RFID", "RGB", "RHEL", "RHL",
            "RIA" "RIAA", "RIP", "RIR", "RISC", "RISC OS", "RJE", "RLE", "RLL",
            "rmdir" "RMI", "RMS", "ROM", "ROM-DOS", "ROMB", "RPA", "RPC",
            "RPG" "RPM", "RRAS", "RSA", "RSI", "RSS", "RSVP", "RTAI", "RTC",
            "RTE" "RTEMS", "RTF", "RTL", "RTMP", "RTOS", "RTP", "RTS", "RTSP",
            "RTTI" "RWD", "S/MIME", "SaaS", "SAM", "SAN", "SAS", "SASS",
            "SATA" "SAX", "sbin", "SBOD", "SBP-2", "sbs", "SBU", "SCADA",
            "SCID" "SCM", "SCP", "SCPC", "SCPI", "SCSA", "SCSI", "SCTP", "SD",
            "SDDL" "SDH", "SDI", "SDIO", "SDK", "SDL", "SDN", "SDP", "SDR",
            "SDRAM" "SDSL", "SE", "SEC", "SEI", "SEO", "SFTP", "SGI", "SGML",
            "SGR" "SHA", "SHDSL", "SIEM", "SIGCAT", "SIGGRAPH", "SIM", "SIMD",
            "SIMM" "SIP", "SISD", "SISO", "SLA", "SLED", "SLES", "SLI", "SLIP",
            "SLM" "SLOC", "SMA", "SMB", "SMBIOS", "SME", "SMF", "SMIL", "SMP",
            "SMPS" "SMS", "SMT", "SMTP", "SNA", "SNMP", "SNTP", "SO-DIMM",
            "SOA" "SOAP", "SoC", "SOE", "SOHO", "SOI", "SOLID", "SOPA", "SP",
            "SPA" "SPARC", "SPF", "SPI", "SPM", "SPMD", "SPOF", "SQL", "SRAM",
            "SSA" "SSD", "SSDP", "SSE", "SSH", "SSI", "SSID", "SSL", "SSO",
            "SSP" "SSSE", "SSSP", "SSTP", "su", "SUS", "SUSE", "SVC", "SVD",
            "SVG" "SVGA", "SWF", "SWT", "Sysop", "TAO", "TAPI", "TASM", "TB",
            "Tcl" "TCP", "TCP/IP", "TCU", "TDMA", "TFT", "TFTP", "TI", "TIFF",
            "TLA" "TLD", "TLS", "TLV", "tmp", "TNC", "TPF", "TPM", "TROFF",
            "TRON" "TRSDOS", "TSO", "TSP", "TSR", "TTA", "TTF", "TTL", "TTS",
            "TTY" "TUCOWS", "TUG", "TWAIN", "UAAG", "UAC", "UART", "UAT", "UB",
            "UCS" "UDDI", "UDMA", "UDP", "UEFI", "UHF", "UI", "UL", "ULA",
            "ULSI" "UMA", "UMB", "UML", "UMPC", "UMTS", "UNC", "UNIVAC", "UPS",
            "URI" "URL", "URN", "USB", "USR", "usr", "UTC", "UTF", "UTP",
            "UTRAN" "UUCP", "UUID", "UUN", "UVC", "UWP", "UX", "var", "VAX",
            "VB" "VBA", "VBS", "VCPI", "VDI", "VDM", "VDSL", "VDU", "VESA",
            "VFAT" "VFS", "VG", "VGA", "VHD", "VHF", "VIRUS", "VLAN", "VLB",
            "VLF" "VLIW", "VLSI", "VLSM", "VM", "VMM", "VNC", "VOD", "VoIP",
            "VoLTE" "VPN", "VPS", "VPU", "VR", "VRAM", "VRML", "VSAM", "VSAT",
            "VT" "VTAM", "VTL", "W3C", "WAFS", "WAI", "WAIS", "WAN", "WAP",
            "WASM" "WBEM", "WCAG", "WCF", "WDM", "WebDAV", "WEP", "WFI",
            "Wi-Fi" "WiMAX", "WinFS", "WinRT", "WINS", "WLAN", "WMA", "WMI",
            "WMV" "WNS", "WOL", "WOR", "WORA", "WORE", "WORM", "WPA", "WPAD",
            "WPAN" "WPF", "WS-D", "WSDL", "WSFL", "WUSB", "WWAN", "WWID",
            "WWN" "WWW", "WYSIWYG", "WZC", "XAG", "XAML", "XCBL", "XDM",
            "XDMCP" "XHTML", "XILP", "XML", "XMMS", "XMPP", "XMS", "XNS", "XP",
            "XPCOM" "XPI", "XPIDL", "XPS", "XSD", "XSL", "XSL-FO", "XSLT",
            "XSS" "XTF", "XUL", "XVGA", "Y2K", "YAAF", "YACC", "YAGNI", "YAML",
            "YARN" "YaST", "ZCAV", "ZCS", "ZIF", "ZIFS", "ZIP", "ZISC", "ZMA",
        )

        __job_area__ = (
            "Accountability", "Accounts", "Applications", "Assurance", "Brand",
            "Branding Communications" "Configuration", "Creative", "Data",
            "Directives Division" "Factors", "Functionality", "Group",
            "Identity" "Implementation Infrastructure", "Integration",
            "Interactions" "Intranet Marketing", "Markets", "Metrics",
            "Mobility" "Operations", "Optimization Paradigm", "Program",
        )

        def protocol(self):
            return choice(self.__protocol__)

        def abbreviation(self):
            return choice(self.__abbreviations__)

        def job_area(self):
            return choice(self.__job_area__)

    fake = Faker()
    fake.add_provider(ExtraProvider)

except ImportError:
    fake = None
